diff --git a/ratbagd/ratbagd-profile.c b/ratbagd/ratbagd-profile.c
index f640ad62e..50de0edd6 100644
--- a/ratbagd/ratbagd-profile.c
+++ b/ratbagd/ratbagd-profile.c
@@ -347,6 +347,51 @@ ratbagd_profile_is_enabled(sd_bus *bus,
 	return sd_bus_message_append(reply, "b", enabled);
 }
 
+static int
+ratbagd_profile_set_name(sd_bus *bus,
+			 const char *path,
+			 const char *interface,
+			 const char *property,
+			 sd_bus_message *m,
+			 void *userdata,
+			 sd_bus_error *error)
+{
+	struct ratbagd_profile *profile = userdata;
+	char *name;
+	int r;
+
+	r = sd_bus_message_read(m, "s", &name);
+	if (r < 0)
+		return r;
+
+	r = ratbag_profile_set_name(profile->lib_profile, name);
+
+	if (r == 0) {
+		sd_bus_emit_properties_changed(bus,
+					       profile->path,
+					       RATBAGD_NAME_ROOT ".Profile",
+					       "Name",
+					       NULL);
+	}
+
+	return r;
+}
+
+static int
+ratbagd_profile_get_name(sd_bus *bus,
+			 const char *path,
+			 const char *interface,
+			 const char *property,
+			 sd_bus_message *reply,
+			 void *userdata,
+			 sd_bus_error *error)
+{
+	struct ratbagd_profile *profile = userdata;
+	const char *name = ratbag_profile_get_name(profile->lib_profile);
+
+	return sd_bus_message_append(reply, "s", name);
+}
+
 static int
 ratbagd_profile_get_capabilities(sd_bus *bus,
 				 const char *path,
@@ -360,6 +405,7 @@ ratbagd_profile_get_capabilities(sd_bus *bus,
 	struct ratbag_profile *lib_profile = profile->lib_profile;
 	enum ratbag_profile_capability cap;
 	enum ratbag_profile_capability caps[] = {
+		RATBAG_PROFILE_CAP_WRITABLE_NAME,
 	};
 	int r;
 	size_t i;
@@ -382,6 +428,10 @@ ratbagd_profile_get_capabilities(sd_bus *bus,
 
 const sd_bus_vtable ratbagd_profile_vtable[] = {
 	SD_BUS_VTABLE_START(0),
+	SD_BUS_WRITABLE_PROPERTY("Name", "s",
+				 ratbagd_profile_get_name,
+				 ratbagd_profile_set_name, 0,
+				 SD_BUS_VTABLE_UNPRIVILEGED|SD_BUS_VTABLE_PROPERTY_EMITS_CHANGE),
 	SD_BUS_WRITABLE_PROPERTY("Enabled", "b",
 				 ratbagd_profile_is_enabled,
 				 ratbagd_profile_set_enabled, 0,
diff --git a/ratbagd/ratbagd.c b/ratbagd/ratbagd.c
index 8e8347562..87e8529b9 100644
--- a/ratbagd/ratbagd.c
+++ b/ratbagd/ratbagd.c
@@ -266,6 +266,7 @@ static const struct ratbag_test_device ratbagd_test_device_descr = {
 			},
 			.active = false,
 			.dflt = true,
+			.caps = { RATBAG_PROFILE_CAP_WRITABLE_NAME },
 		},
 		{
 			.buttons = {
diff --git a/src/hidpp20.c b/src/hidpp20.c
index d805f0787..9152ee54f 100644
--- a/src/hidpp20.c
+++ b/src/hidpp20.c
@@ -29,6 +29,7 @@
  *   https://drive.google.com/folderview?id=0BxbRzx7vEV7eWmgwazJ3NUFfQ28&usp=sharing
  */
 
+#include "config.h"
 #include <assert.h>
 #include <errno.h>
 #include <stdbool.h>
diff --git a/src/libratbag-private.h b/src/libratbag-private.h
index 9c881b61a..48c02cc92 100644
--- a/src/libratbag-private.h
+++ b/src/libratbag-private.h
@@ -260,6 +260,7 @@ struct ratbag_led {
 struct ratbag_profile {
 	int refcount;
 	void *userdata;
+	char *name;
 
 	struct list link;
 	unsigned index;
diff --git a/src/libratbag-util.h b/src/libratbag-util.h
index 9a5859b9a..7e667eee8 100644
--- a/src/libratbag-util.h
+++ b/src/libratbag-util.h
@@ -116,6 +116,23 @@ snprintf_safe(char *buf, size_t n, const char *fmt, ...)
 #define sprintf_safe(buf, fmt, ...) \
 	snprintf_safe(buf, ARRAY_LENGTH(buf), fmt, __VA_ARGS__)
 
+static inline void *
+asprintf_safe(const char *fmt, ...)
+{
+	va_list args;
+	int rc;
+	char *result;
+
+	va_start(args, fmt);
+	rc = vasprintf(&result, fmt, args);
+	va_end(args);
+
+	if (rc < 0)
+		abort();
+
+	return result;
+}
+
 static inline void
 msleep(unsigned int ms)
 {
diff --git a/src/libratbag.c b/src/libratbag.c
index 515a65f13..cba9ee089 100644
--- a/src/libratbag.c
+++ b/src/libratbag.c
@@ -666,6 +666,7 @@ ratbag_create_profile(struct ratbag_device *device,
 						   sizeof(*profile->resolution.modes));
 	profile->resolution.num_modes = num_resolutions;
 	profile->is_enabled = true;
+	profile->name = asprintf_safe("Profile %d", index + 1);
 
 	list_insert(&device->profiles, &profile->link);
 	list_init(&profile->buttons);
@@ -746,6 +747,9 @@ ratbag_profile_destroy(struct ratbag_profile *profile)
 
 	free(profile->resolution.modes);
 
+	if (profile->name)
+		free(profile->name);
+
 	list_remove(&profile->link);
 	free(profile);
 }
@@ -1535,6 +1539,30 @@ ratbag_profile_get_led(struct ratbag_profile *profile,
 	return NULL;
 }
 
+LIBRATBAG_EXPORT const char *
+ratbag_profile_get_name(struct ratbag_profile *profile)
+{
+	return profile->name;
+}
+
+LIBRATBAG_EXPORT int
+ratbag_profile_set_name(struct ratbag_profile *profile,
+			const char *name)
+{
+	char *name_copy = strdup_safe(name);
+
+	if (!ratbag_profile_has_capability(profile,
+					   RATBAG_PROFILE_CAP_WRITABLE_NAME))
+		return RATBAG_ERROR_CAPABILITY;
+
+	if (profile->name)
+		free(profile->name);
+
+	profile->name = name_copy;
+
+	return 0;
+}
+
 LIBRATBAG_EXPORT void
 ratbag_set_user_data(struct ratbag *ratbag, void *userdata)
 {
diff --git a/src/libratbag.h b/src/libratbag.h
index a85d36974..60bb866bf 100644
--- a/src/libratbag.h
+++ b/src/libratbag.h
@@ -651,6 +651,14 @@ ratbag_device_get_num_leds(struct ratbag_device *device);
  */
 enum ratbag_profile_capability {
 	RATBAG_PROFILE_CAP_NONE = 0,
+	/**
+	 * The device has the capability to write a name to a profile
+	 * and store it in its flash.
+	 *
+	 * Any changes uploaded to the device will be cached in libratbag
+	 * and will be committed to it after a commit only.
+	 */
+	RATBAG_PROFILE_CAP_WRITABLE_NAME = 100,
 };
 /**
  * @ingroup profile
@@ -688,6 +696,31 @@ int
 ratbag_profile_has_capability(const struct ratbag_profile *profile,
 			      enum ratbag_profile_capability cap);
 
+/**
+ * @ingroup profile
+ *
+ * Return the ratbag profile name.
+ *
+ * @param profile A previously initialized ratbag profile
+ * @return the profile name
+ */
+const char *
+ratbag_profile_get_name(struct ratbag_profile *profile);
+
+/**
+ * @ingroup profile
+ *
+ * Set the name of a ratbag profile.
+ *
+ * @param profile A previously initialized ratbag profile
+ * @param name the profile name
+ *
+ * @return 0 on success or an error code otherwise
+ */
+int
+ratbag_profile_set_name(struct ratbag_profile *profile,
+			const char *name);
+
 /**
  * @ingroup profile
  *
diff --git a/tools/ratbagctl.in b/tools/ratbagctl.in
index dc49659b5..776a273d2 100755
--- a/tools/ratbagctl.in
+++ b/tools/ratbagctl.in
@@ -27,7 +27,7 @@ import evdev
 import sys
 import argparse
 
-from ratbagd import Ratbagd, RatbagdDevice, RatbagdProfile, RatbagdResolution, RatbagdButton, RatbagdLed, RatbagdDBusUnavailable  # NOQA
+from ratbagd import Ratbagd, RatbagdDevice, RatbagdProfile, RatbagdResolution, RatbagdButton, RatbagdLed, RatbagdDBusUnavailable, RatbagError  # NOQA
 
 button_specials_strmap = {
     RatbagdButton.ACTION_SPECIAL_UNKNOWN: "unknown",
@@ -248,6 +248,7 @@ def print_profile(d, p, level):
                                                        " (disabled)" if not p.enabled else "",
                                                        " (active)" if p.is_active else ""))
     if p.enabled:
+        print(" " * level + "Name : '{}'".format(p.name))
         print(" " * level + "Resolutions:")
         for r in p.resolutions:
             print_resolution(d, p, r, level + 2)
@@ -495,6 +496,19 @@ def func_profile_get(r, args):
     print_profile(d, p, 0)
 
 
+def func_profile_name_get(r, args):
+    p, d = find_profile(r, args)
+    print(p.name)
+
+
+def func_profile_name_set(r, args):
+    p, d = find_profile(r, args)
+    p.name = args.name
+    if p.name != args.name:
+        raise RatbagError("The device is not capable to assign a profile name.")
+    d.commit()
+
+
 def func_profile_active_get(r, args):
     d = find_device(r, args)
     for p in d.profiles:
@@ -692,6 +706,33 @@ parser_def = [
                     help_str: 'Show current active profile',
                     func: func_profile_get,
                 },
+                {
+                    of_type: switch,
+                    name: 'name',
+                    help_str: 'access profile name information',
+                    switch: [
+                        {
+                            of_type: command,
+                            name: 'get',
+                            help_str: 'Show the name of the profile',
+                            func: func_profile_name_get,
+                        },
+                        {
+                            of_type: command,
+                            name: 'set',
+                            help_str: 'Set the name of the profile',
+                            pos_args: [
+                                {
+                                    of_type: argument,
+                                    name: 'name',
+                                    metavar: 'blah',
+                                    help_str: 'The name to set',
+                                },
+                            ],
+                            func: func_profile_name_set,
+                        },
+                    ],
+                },
                 {
                     of_type: command,
                     name: 'enable',
diff --git a/tools/ratbagctl.test.in b/tools/ratbagctl.test.in
index 4c8598746..918a2da59 100755
--- a/tools/ratbagctl.test.in
+++ b/tools/ratbagctl.test.in
@@ -97,6 +97,11 @@ class TestRatbagCtl(unittest.TestCase):
         self.assertNotEqual(returncode, 0)
         return stdout
 
+    def launch_fail_with_exception_test(self, params, exception):
+        with self.assertRaises(exception):
+            returncode, stdout, stderr = self.run_ratbagctl(params)
+        return ''
+
     @classmethod
     def setProfile(cls, profile):
         cls.run_ratbagctl("Profile active set {} test_device".format(profile))
@@ -130,6 +135,26 @@ class TestRatbgagCtlProfile(TestRatbagCtl):
         super(TestRatbgagCtlProfile, cls).setUpClass()
         cls.setProfile(0)
 
+    def test_profile_name_get(self):
+        command = "profile 0 name get"
+        r = self.launch_good_test(command + " test_device")
+        self.assertEqual(r, 'Profile 1')
+        self.launch_fail_test(command)
+        self.launch_fail_test(command + " X test_device")
+        self.launch_fail_test("profile name get test_device")
+
+    def test_profile_name_set(self):
+        r = self.launch_good_test("profile 1 name get test_device")
+        self.assertEqual(r, 'Profile 2')
+        self.launch_good_test("profile 1 name set banana test_device")
+        r = self.launch_good_test("profile 1 name get test_device")
+        self.assertEqual(r, 'banana')
+        # profile 0 doesn't have the capability RATBAG_PROFILE_CAP_WRITABLE_NAME
+        self.launch_fail_with_exception_test("profile 0 name set kiwi test_device", toolbox.RatbagError)
+        self.launch_fail_test("profile 1 name set blah")
+        self.launch_fail_test("profile 1 name set blah X test_device")
+        self.launch_fail_test("profile name set blah test_device")
+
     def test_profile_active_get(self):
         command = "profile active get"
         r = self.launch_good_test(command + " test_device")
diff --git a/tools/ratbagd.py b/tools/ratbagd.py
index 413f842f8..397cb2833 100644
--- a/tools/ratbagd.py
+++ b/tools/ratbagd.py
@@ -289,6 +289,8 @@ def commit(self):
 class RatbagdProfile(_RatbagdDBus):
     """Represents a ratbagd profile."""
 
+    CAP_WRITABLE_NAME = 100
+
     def __init__(self, object_path):
         _RatbagdDBus.__init__(self, "Profile", object_path)
 
@@ -303,6 +305,20 @@ def capabilities(self):
         return self._get_dbus_property("Capabilities")
 
     @GObject.property
+    def name(self):
+        """The name of the profile"""
+        return self._get_dbus_property("Name")
+
+    @name.setter
+    def name(self, name):
+        """Set the name of this profile.
+
+        @param name The new name, as string"""
+        if RatbagdProfile.CAP_WRITABLE_NAME in self.capabilities:
+            return self._set_dbus_property("Name", "s", name)
+        return RatbagErrorCode.RATBAG_ERROR_CAPABILITY
+
+    @GObject.Property
     def index(self):
         """The index of this profile."""
         return self._get_dbus_property("Index")
diff --git a/tools/toolbox.py b/tools/toolbox.py
index 57c3f088f..4e9ee3bc3 100644
--- a/tools/toolbox.py
+++ b/tools/toolbox.py
@@ -97,7 +97,7 @@ def terminate_ratbagd(ratbagd):
 
 ratbagctl = import_non_standard_path(RATBAGCTL_NAME, RATBAGCTL_PATH)
 
-from ratbagctl import open_ratbagd, get_parser
+from ratbagctl import open_ratbagd, get_parser, RatbagError
 
 __all__ = [
     RATBAGCTL_NAME,
@@ -109,4 +109,5 @@ def terminate_ratbagd(ratbagd):
     terminate_ratbagd,
     open_ratbagd,
     get_parser,
+    RatbagError,
 ]
